// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPU1Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;
var snridCPU2Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0300;
var snridCPU1Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0210;
var snridCPU2Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0310;
var snridFBDCh0Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0400;
var snridFBDCh0Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0410;
var snridFBDCh1Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0440;
var snridFBDCh1Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0450;
var snridFBDCh2Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0480;
var snridFBDCh2Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0490;
var snridFBDCh3Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04C0;
var snridFBDCh3Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04D0;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;
var snridFan7Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0170;
var snridFan8Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;
var snridFan9Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0190;

var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 5, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 5, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 6, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 6, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 6, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 6, 7).extra", snsridHasDMI)
    )
);
var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_cpufan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2 = new SysComponentInfo ('FAN2', "parent.once.GSensorNames[parent.once.snridFan2Speed]", 'info_cpufan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed)
    )
);
var compFan3 = new SysComponentInfo ('FAN3', "parent.once.GSensorNames[parent.once.snridFan3Speed]", 'info_frontfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4 = new SysComponentInfo ('FAN4', "parent.once.GSensorNames[parent.once.snridFan4Speed]", 'info_frontfan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed)
    )
);
var compFan5 = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_frontfan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);
var compFan6 = new SysComponentInfo ('FAN6', "parent.once.GSensorNames[parent.once.snridFan6Speed]", 'info_frontfan4.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan6Speed).unit]", snridFan6Speed)
    )
);
var compFan7 = new SysComponentInfo ('FAN7', "parent.once.GSensorNames[parent.once.snridFan7Speed]", 'info_rearfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan7Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan7Speed).unit]", snridFan7Speed)
    )
);
var compFan8 = new SysComponentInfo ('FAN8', "parent.once.GSensorNames[parent.once.snridFan8Speed]", 'info_rearfan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan8Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan8Speed).unit]", snridFan8Speed)
    )
);
var compFan9 = new SysComponentInfo ('FAN9', "parent.once.GSensorNames[parent.once.snridFan9Speed]", 'info_fbd_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan9Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan9Speed).unit]", snridFan9Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_winbond.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2)
    )
);
var compMemory;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot1Temperature)")
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 5, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 5, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 6, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 6, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 7, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 7, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 8, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 8, 9).value)", snsridHasDMI),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).unit]", snridFBDCh0Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).unit]", snridFBDCh0Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).unit]", snridFBDCh1Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).unit]", snridFBDCh1Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).unit]", snridFBDCh2Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).unit]", snridFBDCh2Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).unit]", snridFBDCh3Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).unit]", snridFBDCh3Slot1Temperature)
        )
    );
}
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'",
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);


var theSystemComponents = new Tuple (
    compIOConnector,
    compFan1,
    compFan2,
    compFan3,
    compFan4,
    compFan5,
    compFan6,
    compFan7,
    compFan8,
    compFan9,
    compMotherboard,
    compIPMI,
    compMemory,
    compPCI,
    compCPU1,
    compCPU2
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/dsbf-de_sas/';
var theSystem = new SysModel ('model.jpg', chassis_tower);
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 97, 128, 122, 179), compIPMI),
            new AnArea (new Rect ( 82, 147,  92, 164), compMotherboard),
            new AnArea (new Rect (218, 121, 228, 133), compFan1),
            new AnArea (new Rect (102, 181, 114, 191), compFan2),
            new AnArea (new Rect (103, 206, 114, 217), compFan3),
            new AnArea (new Rect (103, 193, 114, 204), compFan4),
            new AnArea (new Rect ( 35, 201,  46, 212), compFan5),
            new AnArea (new Rect ( 35, 185,  46, 196), compFan6),
            new AnArea (new Rect (187,  14, 197,  25), compFan7),
            new AnArea (new Rect (168,  13, 179,  25), compFan8),
            new AnArea (new Rect (129,  40, 142,  55), compFan9),
            new AnArea (new Rect ( 39,  30, 116, 114), compPCI),
            new AnArea (new Rect (164,  26, 222, 122), compMemory),
            new AnArea (new Rect (175, 144, 221, 180), compCPU1),
            new AnArea (new Rect (122, 144, 168, 180), compCPU2)
        ),
        new Tuple (
            
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed, new Point (214, 119)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'], snridFan2Speed, new Point (99, 178)), 
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'], snridFan3Speed, new Point (99, 203)), 
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'], snridFan4Speed, new Point (99, 190)), 
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (31, 198)), 
            new quadruple ('AL_FAN6', parent.asID['IDV_TYPE_SNR'], snridFan6Speed, new Point (31, 182)),
            new quadruple ('AL_FAN7', parent.asID['IDV_TYPE_SNR'], snridFan7Speed, new Point (183, 11)), 
            new quadruple ('AL_FAN8', parent.asID['IDV_TYPE_SNR'], snridFan8Speed, new Point (164, 11)), 
            new quadruple ('AL_FAN9', parent.asID['IDV_TYPE_SNR'], snridFan9Speed, new Point (126, 39)), 
            new quadruple ('AL_FBDC0S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot0Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC0S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot1Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC1S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot0Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC1S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot1Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC2S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot0Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC2S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot1Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC3S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot0Temperature, new Point (184, 66)),
            new quadruple ('AL_FBDC3S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot1Temperature, new Point (184, 66)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature1, new Point (189, 155)),
            new quadruple ('AL_CPU1TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature2, new Point (189, 155)),
            new quadruple ('AL_CPU2TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature1, new Point (136, 155)),
            new quadruple ('AL_CPU2TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature2, new Point (136, 155)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (189, 155)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage, new Point (136, 155)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (80, 147)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (80, 147))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 10, 107, 150, 139), compIOConnector)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2"
    )
);


